C. Planar Reflections(codeforces)

C. Planar Reflections

Gaurang has grown up in a mystical universe. He is faced by n consecutive 2D planes. He shoots a particle of decay age k at the planes.
A particle can pass through a plane directly, however, every plane produces an identical copy of the particle going in the opposite direction with a decay age k−1. If a particle has decay age equal to 1, it will NOT produce a copy.
For example, if there are two planes and a particle is shot with decay age 3 (towards the right), the process is as follows: (here, D(x) refers to a single particle with decay age x)

  1. the first plane produces a D(2) to the left and lets D(3) continue on to the right;
  2. the second plane produces a D(2) to the left and lets D(3) continue on to the right;
  3. the first plane lets D(2) continue on to the left and produces a D(1) to the right;
  4. the second plane lets D(1) continue on to the right (D(1) cannot produce any copies).

In total, the final multiset S of particles is {D(3),D(2),D(2),D(1)}. (See notes for visual explanation of this test case.)
Gaurang is unable to cope up with the complexity of this situation when the number of planes is too large. Help Gaurang find the size of the multiset S, given n and k.
Since the size of the multiset can be very large, you have to output it modulo 109+7.
Note: Particles can go back and forth between the planes without colliding with each other.

Input

The first line of the input contains the number of test cases t (1≤t≤100). Then, t lines follow, each containing two integers n and k (1≤n,k≤1000).
Additionally, the sum of n over all test cases will not exceed 1000, and the sum of k over all test cases will not exceed 1000. All test cases in one test are different.

Output

Output t integers. The i-th of them should be equal to the answer to the i-th test case.

Examples
  • inputCopy
4
2 3
2 2
3 1
1 3
  • outputCopy
4
3
1
2
  • inputCopy
3
1 1
1 500
500 250
  • outputCopy
1
2
257950823
Note

Let us explain the first example with four test cases.
Test case 1: (n=2, k=3) is already explained in the problem statement.
See the below figure of this simulation. Each straight line with a different color represents the path of a different particle. As you can see, there are four distinct particles in the multiset. Note that the vertical spacing between reflected particles is for visual clarity only (as mentioned before, no two distinct particles collide with each other)
电子运动轨迹
Test case 2: (n=2, k=2) is explained as follows:
1.the first plane produces a D(1) to the left and lets D(2) continue on to the right;
2.the second plane produces a D(1) to the left and lets D(2) continue on to the right;
3. the first plane lets D(1) continue on to the left (D(1) cannot produce any copies).
Total size of multiset obtained {D(1),D(1),D(2)} is equal to three.
Test case 3: (n=3, k=1), there are three planes, but decay age is only one. So no new copies are produced while the one particle passes through the planes. Hence, the answer is one.
Test case 4: (n=1, k=3) there is only one plane. The particle produces a new copy to the left. The multiset {D(2),D(3)} is of size two.

解析

废话不多说,直接上图
题目不是很难, 仔细研究并理解题目,很容易就能做出来
在这里插入图片描述

代码
#include<bits/stdc++.h>
using namespace std;

const int mod = 1e9+7; 
int dp[1005][1005] = {0};

int main(){
    int T;
    scanf("%d", &T);
    for(int t = 0; t < T; t++){
        memset(dp, 0, sizeof(dp));
        int n, m, ans = 0, num = 0;
        cin>>n>>m;
        dp[1][1] = 1;
        for(int i = 1; i <= m; i++){
            if(i % 2 == 1){
                for(int j = 2; j <= n; j++){
                    dp[i][j] = dp[i-1][j-1] + dp[i][j-1];
                    dp[i][j] = dp[i][j] % mod;
                    // cout<<dp[i][j]<<" ";
                }
                ans = (dp[i][n] + ans) % mod;
            } else {
                for(int j = n - 1; j >= 1; j--){
                    dp[i][j] = dp[i-1][j+1] + dp[i][j+1];
                    dp[i][j] = dp[i][j] % mod;
                    // cout<<dp[i][j]<<" ";
                }
                ans = (dp[i][1] + ans) % mod;
            }
            // cout<<endl;
        }
        if(m == 1) ans = 0;
        cout<<ans+1<<endl;
    }
    return 0;
}
  • 0
    点赞
  • 0
    收藏
    觉得还不错? 一键收藏
  • 打赏
    打赏
  • 2
    评论
评论 2
添加红包

请填写红包祝福语或标题

红包个数最小为10个

红包金额最低5元

当前余额3.43前往充值 >
需支付:10.00
成就一亿技术人!
领取后你会自动成为博主和红包主的粉丝 规则
hope_wisdom
发出的红包

打赏作者

我在社会底层收垃圾

你的鼓励将是我创作的最大动力

¥1 ¥2 ¥4 ¥6 ¥10 ¥20
扫码支付:¥1
获取中
扫码支付

您的余额不足,请更换扫码支付或充值

打赏作者

实付
使用余额支付
点击重新获取
扫码支付
钱包余额 0

抵扣说明:

1.余额是钱包充值的虚拟货币,按照1:1的比例进行支付金额的抵扣。
2.余额无法直接购买下载,可以购买VIP、付费专栏及课程。

余额充值